//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <time.h>
#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
#include "Unit4.h"
#include "Unit5.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Trayicon"
#pragma link "Ggauge"
#pragma resource "*.dfm"
TForm1 *Form1;
bool Paused;
HANDLE BrainTransFile;
TNeuralNet *NeuralNet;
TUpdateDataBase *UpdateDataBase;
LPVOID MAP_POINTER;
int *POINTER;
const float DIV=1000;
const int TimeInterval=500;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
Timer1->Interval=TimeInterval;
AnsiString FName=Application->ExeName;
FName=FName.SubString(1,FName.Length()-3)+"hlp";
Application->HelpFile=FName;

POINTER=0;//   
TrayIcon1->IconIndex=4;

NeuralNet=new TNeuralNet(true);
UpdateDataBase=new TUpdateDataBase(true);
BackGroundClick(NULL);
FalseLabels();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrayIcon1Restore(TObject *Sender)
{
if(POINTER)*POINTER=0x00000000;
Timer1Timer(NULL);
BackGroundClick(NULL);
ToolBar1->Left=416;
Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OkClick(TObject *Sender)
{
NeuralNet->Priority=tpLower;//   -  
Hide();
TrayIcon1->Minimize();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ExitClick(TObject *Sender)
{
if(NeuralNet->Status){
  if(MessageDlg("  ?",mtWarning,TMsgDlgButtons()<<mbYes<<mbNo,0)==mrYes)
    Application->Terminate();
}
else
  if(!NeuralNet->Suspended||!UpdateDataBase->Suspended){
    if(MessageDlg("!     \n   ,    .\n?",mtWarning,TMsgDlgButtons()<<mbYes<<mbNo,0)==mrYes)
      Application->Terminate();
  }
  else Application->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{

if(Tag!=TagUpdateDataBase){
  HANDLE DurakTransFile=OpenFileMapping(FILE_MAP_WRITE,false,"Durak_Transmition_file");
  if(DurakTransFile!=NULL){
    LPVOID MAP_POINTER=MapViewOfFile(DurakTransFile,FILE_MAP_WRITE,0,0,0);
    if(MAP_POINTER!=NULL){
      int *PointerToMap=(int*)MAP_POINTER;
      if(*PointerToMap==1){//    
        try{*PointerToMap=0;}
        catch (Exception &exception){Application->ShowException(&exception);}

        UpdateGameDataBase();
      }
      UnmapViewOfFile(MAP_POINTER);
    }
    CloseHandle(DurakTransFile);
  }
}


if(Tag==TagUpdateDataBase){
  TrayIcon1->Hint="    ";

  Timer1->Interval=TimeInterval;
  if(TrayIcon1->IconIndex==2)TrayIcon1->IconIndex=3;
  else TrayIcon1->IconIndex=2;

  if(UpdateDataBase->ErrNo==FatalError){//   - 
    Timer1->Enabled=false;
    MessageDlg(UpdateDataBase->ErrorString,mtError,TMsgDlgButtons()<<mbOK,0);
    ExitClick(NULL);
    return;
  }

  if(UpdateDataBase->Suspended){
    NumTrains=UpdateDataBase->NumTrains;
    NeuralNet->NumTrains=NumTrains;// 
    NeuralNet->NeedToInit=UpdateDataBase->NeedToInit;
    Examples->Caption=NumTrains;// 
    if(!NumTrains){FalseLabels();Tag=0;return;}

    DBFile=UpdateDataBase->DBFile;
    NeuralNet->FileWgt=UpdateDataBase->FileWgt;
    NeuralNet->TempFileWgt=UpdateDataBase->TempFileWgt;
    NeuralNet->DBFile=DBFile;//  
    ProgressBar1->Max=NumTrains;
    CurrentProgress->Max=NumTrains;

    Label1->Enabled=true;
    Examples->Enabled=true;
    Label4->Enabled=true;
    CurrentError->Enabled=true;
    Label2->Enabled=true;
    Status->Enabled=true;
    CurrentProgress->Enabled=true;
    Label3->Enabled=true;
    Label6->Enabled=true;
    LastTime->Enabled=true;
    ProgressBar1->Enabled=true;
    GroupBox4->Enabled=true;
    GroupBox2->Enabled=true;
    GroupBox3->Enabled=true;


    Label8->Enabled=true;
    Moch->Enabled=true;
    Label12->Enabled=true;
    Train->Enabled=true;
    RandomWeight->Enabled=true;
    Start->Enabled=false;
    Pause->Enabled=true;
    Paused=false;

    Tag=TagNeural;
    NeuralNet->StartTime=time(NULL);// 
//    NeuralNet->Suspended=false;
    NeuralNet->Memory=UpdateDataBase->Memory;
    NeuralNet->Status=-1;
    NeuralNet->Resume();
  }
}

if(Tag==TagNeural){
  if(NeuralNet->Status!=3)
    TrayIcon1->Hint=ProgressBar1->Caption+"  .";
  else TrayIcon1->Hint="       .";

  if(Form1->Showing&&NeuralNet->Status==1||NeuralNet->Status==2){
    Examples->Caption=NumTrains;// 
    int t=time(NULL)-NeuralNet->StartTime;
    LastTime->Caption=IntToStr(t/3600)+"."+IntToStr((t%3600)/60)+":"+IntToStr(t%60);// 


    ProgressBar1->Progress=NeuralNet->CorrectAnsw;//  
    CurrentProgress->Position=NeuralNet->CurrentPosition;
    CurrentError->Caption=FloatToStrF(NeuralNet->CurrentError,ffGeneral,8,8);
    Train->Caption=NeuralNet->Train;

    if(NeuralNet->MaximumError){
      Moch->Caption=FloatToStrF(NeuralNet->MaximumError,ffFixed,8,8);
      if(NeuralNet->Direcrion)Label6->Caption="";else Label6->Caption="";//  
    }
    else Label6->Caption="";
    Label6->Left=Moch->Left+Canvas->TextWidth(Moch->Caption+"-");

    if(NeuralNet->Status==1)Status->Caption="  ...";
    else Status->Caption=" ...";

    ShowKoef();
  }

  if(!NeuralNet->Status||NeuralNet->Status==4){// 
    if(TrayIcon1->IconIndex==2)TrayIcon1->IconIndex=3;
    else TrayIcon1->IconIndex=2;
    if(NeuralNet->Status==4)TrayIcon1->Hint="   .";
    else{TrayIcon1->Hint="   .";FalseLabels();}
  }
  else
    if(!TrayIcon1->IconIndex)TrayIcon1->IconIndex=1;
    else TrayIcon1->IconIndex=0;

  if(NeuralNet->Suspended&&!Paused&&NeuralNet->FileWgt==-1){FalseLabels();*POINTER=1;Tag=0;}//        
  Timer1->Interval=TimeInterval;
}
else
if(!Tag){
  if(TrayIcon1->IconIndex==4){//  
    TrayIcon1->IconIndex=5;
    Timer1->Interval=125;
  }
  else{
    TrayIcon1->IconIndex=4;
    Timer1->Interval=random(6000)+500;
  }
  TrayIcon1->Hint="     ";
 }
}
//---------------------------------------------------------------------------
void TForm1::UpdateGameDataBase(){//    
if(!NeuralNet->Suspended)NeuralNet->Suspend();
FalseLabels();
UpdateDataBase->Resume();
//UpdateDataBase->Suspended=false;
Tag=TagUpdateDataBase;//   

//ProgressBar1->Max=NumTrains;
//ProgressBar1->Position=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
NeuralNet->Suspend();
Parametrs->TMomentum=NeuralNet->TMomentum;
Parametrs->TLearn=NeuralNet->Learn;
Parametrs->SaveOptions();
TrayIcon1->Hint="    ...";
TrayIcon1->IconIndex=2;
NeuralNet->SaveTempWeight();
NeuralNet->Terminate();
delete NeuralNet;


UpdateDataBase->Suspend();
UpdateDataBase->Terminate();
delete UpdateDataBase;

if(MAP_POINTER!=NULL)UnmapViewOfFile(MAP_POINTER);
if(BrainTransFile!=NULL)CloseHandle(BrainTransFile);
}
//---------------------------------------------------------------------------
void  TForm1::FalseLabels(){
    CurrentProgress->Position=0;
    CurrentError->Caption="?";
    ProgressBar1->Progress=0;
    Moch->Caption="?";
//    Train->Caption="?";
    Label6->Caption="";
    Status->Caption=" ";

    Label1->Enabled=false;
    Label6->Enabled=false;
    Examples->Enabled=false;
    Label4->Enabled=false;
    CurrentError->Enabled=false;
    Label2->Enabled=false;
    Status->Enabled=false;
    CurrentProgress->Enabled=false;
    Label3->Enabled=false;
    LastTime->Enabled=false;
    ProgressBar1->Enabled=false;
    Label8->Enabled=false;
    Moch->Enabled=false;
    Label12->Enabled=false;
    Train->Enabled=false;

    GroupBox4->Enabled=false;
    GroupBox2->Enabled=false;
    GroupBox3->Enabled=false;

    RandomWeight->Enabled=false;
    Start->Enabled=false;
    Pause->Enabled=false;
    Paused=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BackGroundClick(TObject *Sender)
{
if(BackGround->Down)NeuralNet->Priority=tpLower;
else NeuralNet->Priority=tpNormal;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::RandomWeightClick(TObject *Sender)
{
if(MessageDlg("      .\n    . ?",mtWarning,TMsgDlgButtons()<<mbYes<<mbNo,0)==mrYes){
 NeuralNet->Suspend();
 NeuralNet->InitWeight();
 NeuralNet->Resume();
}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StartClick(TObject *Sender)
{
Start->Enabled=false;
Pause->Enabled=true;
Timer1->Enabled=true;
Paused=false;
NeuralNet->Resume();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PauseClick(TObject *Sender)
{
Start->Enabled=true;
Pause->Enabled=false;
Timer1->Enabled=false;
Paused=true;
NeuralNet->Suspend();
TrayIcon1->Hint="    .";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BackGroundMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if(Sender==Ok)Ok->SetFocus();
else if(Sender==Exit)Exit->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PropertiesClick(TObject *Sender)
{
if(Parametrs->ShowModal()==mrOk)Opt();
}
//---------------------------------------------------------------------------
void TForm1::Opt(){
NeuralNet->TAlfa=Parametrs->TAlfa;
NeuralNet->TMomentum=Parametrs->TMomentum;
NeuralNet->TLearn=Parametrs->TLearn;
NeuralNet->TSpeedUpMom=Parametrs->TSpeedUpMom;
NeuralNet->TSpeedDownMom=Parametrs->TSpeedDownMom;
NeuralNet->TMinProiz=Parametrs->TMinProiz;
NeuralNet->TMaxWei=Parametrs->TMaxWei;
NeuralNet->TMinMom=Parametrs->TMinMom;
NeuralNet->TMaxSum=float(Parametrs->TMaxSum);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::HelpClick(TObject *Sender)
{
About->ShowModal();
}
//---------------------------------------------------------------------------
void TForm1::Init(){
MAP_POINTER=NULL;

//  
BrainTransFile=CreateFileMapping((HANDLE)0xFFFFFFFF,NULL,PAGE_READWRITE,0,8,"Brain_Transmition_file");
if(BrainTransFile==NULL){
  Application->MessageBox("      .\n  .", NULL, MB_OK|MB_ICONSTOP);
  Application->Terminate();
  return;
}
//   
if(GetLastError()==ERROR_ALREADY_EXISTS){
  Application->Terminate();
  return;
}
//   
MAP_POINTER=MapViewOfFile(BrainTransFile,FILE_MAP_WRITE,0,0,0);
if(MAP_POINTER==NULL){
  Application->MessageBox("   .\n  .", NULL, MB_OK|MB_ICONSTOP);
  Application->Terminate();
  return;
}
POINTER=(int*)MAP_POINTER;
*POINTER=0;


UpdateGameDataBase();
}
//---------------------------------------------------------------------------
void TForm1::ShowKoef(){
  Error->Caption=FloatToStrF(NeuralNet->NU,ffGeneral,2,4);
  Alfa->Caption=FloatToStrF(NeuralNet->Alfa,ffGeneral,2,4);
  Learn->Caption=FloatToStrF(NeuralNet->Learn,ffGeneral,2,4);
}
//---------------------------------------------------------------------------

